package net.minecraft.src;

import java.util.ArrayList;
import java.util.Random;

public class AchievementPage {
	private static int nextID = 1;
	private final int id;
	public final ItemStack stackIcon;
	public final String title;
	protected ArrayList<Integer> list = new ArrayList<Integer>();
	
	public AchievementPage() {
		id = 0;
		stackIcon = new ItemStack(Block.grass);
		title = "Minecraft";
		SAPI.Achievements.addPage(this);
	}
	public AchievementPage(ItemStack stackIcon, String title) {
		id = nextID++;
		this.stackIcon = stackIcon;
		this.title = title;
		SAPI.Achievements.addPage(this);
	}
	public boolean equals(Object other) {
		if (other == null) return false;
		if (!(other instanceof AchievementPage)) return false;
		AchievementPage page = (AchievementPage)other;
		return id == page.id;
	}
	public final int getID() {return id;}

	public void addAchievements(Achievement... achievements) {
		for (Achievement a : achievements) list.add(a.statId);
	}

	public int bgGetSprite(Random random, int i, int j) {
		int l = random.nextInt(1+j)+j/2;
		
		Block b = Block.sand;
		if (l > 37 || j == 35) b = Block.bedrock;
		else if (l == 22) b = random.nextInt(2) != 0 ? Block.oreRedstone : Block.oreDiamond;
		else if (l == 10) b = Block.oreIron;
		else if (l == 8) b = Block.oreCoal;
		else if (l > 4) b = Block.stone;
		else if (l > 0) b = Block.dirt;
		return b.blockIndexInTexture;
	}
}