package net.minecraft.src;

public class DimensionBase {
	public final int id;
	public final String name;
	private final Class<? extends WorldProvider> worldProvider;
	private final Class<? extends Teleporter> teleporter;
	public String soundTrigger = "portal.trigger", soundTravel = "portal.travel";
	
	public DimensionBase(int id, String name, Class<? extends WorldProvider> worldProvider, Class<? extends Teleporter> teleporter) {
		this.id = id;
		this.name = name;
		this.worldProvider = worldProvider;
		this.teleporter = teleporter;
		SAPI.Dimension.add(this);
	}
	
	public WorldProvider makeWorldProvider() {
		try {
			return worldProvider.newInstance();
		} catch (Exception e) {return null;}
	}
	public Teleporter makeTeleporter() {
		try {
			return teleporter.newInstance();
		} catch (Exception e) {return null;}
	}
	
	public Loc getDistanceScale(Loc loc, boolean goingOut) {
        return new Loc(loc);
    }
}