package net.minecraft.src;

import java.util.Random;

import net.minecraft.src.Block;
import net.minecraft.src.ItemStack;

public class DungeonLoot
{

    public DungeonLoot(ItemStack itemstack)
    {
        loot = new ItemStack(itemstack.itemID, 1, itemstack.getItemDamage());
        min = max = itemstack.stackSize;
    }

    public DungeonLoot(ItemStack itemstack, int i, int j)
    {
        loot = new ItemStack(itemstack.itemID, 1, itemstack.getItemDamage());
        min = i;
        max = j;
    }

    public ItemStack getStack()
    {
        int i = 0;
        if(loot.itemID <= 255)
        {
            if(Block.blocksList[loot.itemID].getRenderColor(1) != 1)
            {
                i = loot.getItemDamage();
            } else
            if(!loot.getItem().isDamageable())
            {
                i = loot.getItemDamage();
            }
        }
        return new ItemStack(loot.itemID, min + (new Random()).nextInt((max - min) + 1), i);
    }

    public final ItemStack loot;
    public final int min;
    public final int max;
}
