package net.minecraft.src;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.util.ArrayList;

import net.minecraft.client.Minecraft;
import net.minecraft.src.SAPI.Achievements;
import net.minecraft.src.SAPI.Dungeon;
import net.minecraft.src.SAPI.NBT;

public class mod_SAPI extends BaseMod implements INBT {
	private static World worldObj;
	protected static int lockDifficulty = -1;
    private static int counter = 0;
	
	public String Version() {return "r10 (B1.8.1)";}
	
	public mod_SAPI() {
		ModLoader.SetInGameHook(this,true,true);
        ModLoader.SetInGUIHook(this,true,false);
		
		Dungeon.addDungeonLoot(new DungeonLoot(new ItemStack(Item.saddle)));
		Dungeon.addDungeonLoot(new DungeonLoot(new ItemStack(Item.ingotIron),1,4));
		Dungeon.addDungeonLoot(new DungeonLoot(new ItemStack(Item.bread)));
		Dungeon.addDungeonLoot(new DungeonLoot(new ItemStack(Item.wheat),1,4));
		Dungeon.addDungeonLoot(new DungeonLoot(new ItemStack(Item.gunpowder),1,4));
		Dungeon.addDungeonLoot(new DungeonLoot(new ItemStack(Item.silk),1,4));
		Dungeon.addDungeonLoot(new DungeonLoot(new ItemStack(Item.bucketEmpty)));
		Dungeon.addDungeonLoot(new DungeonLoot(new ItemStack(Item.appleGold)),1f/100f);
		Dungeon.addDungeonLoot(new DungeonLoot(new ItemStack(Item.redstone),1,4),1f/2f);
		Dungeon.addDungeonLoot(new DungeonLoot(new ItemStack(Item.record13)),1f/20f);
		Dungeon.addDungeonLoot(new DungeonLoot(new ItemStack(Item.recordCat)),1f/20f);
		Dungeon.addDungeonLoot(new DungeonLoot(new ItemStack(Item.dyePowder,1,3)));
		
		Dungeon.addMob("Skeleton");
		Dungeon.addMob("Zombie",2f);
		Dungeon.addMob("Spider");
		
		NBT.add(this);
		
		new DimensionBase(0,"Overworld",WorldProviderSurface.class,null);
		new DimensionNether();
	}
	
	public boolean OnTickInGame(Minecraft game) {
        if (counter == 1) {
            counter = 0;
            game.displayGuiScreen(new GuiLockDifficulty(game.theWorld));
        }
        tick(game);
        if (!game.theWorld.multiplayerWorld) {
            if (game.theWorld != worldObj) {
                if (worldObj != null) saveNBT(worldObj);
                if (game.theWorld != null) loadNBT(game.theWorld);
                worldObj = game.theWorld;
            }
            if (worldObj != null && (worldObj.worldInfo.getWorldTime() % worldObj.autosavePeriod) == 0L) saveNBT(worldObj);
        }
        return true;
    }

    public boolean OnTickInGUI(Minecraft game, GuiScreen guiscreen) {
        tick(game);
        worldObj = null;
        return true;
    }

    public void tick(Minecraft game) {
        lockDifficulty(game);
    }
    
    public static void updateShouldLock(World world) {
        if (world == null) lockDifficulty = -1;
    }
    public static void lockDifficulty(Minecraft game) {
        if (lockDifficulty == -1) return;
        game.gameSettings.difficulty = lockDifficulty;
    }
    
    public static void saveNBT(World world) {
        try {
            File file = GetWorldSaveLocation(world);
            ArrayList<INBT> list = NBT.getList();
            for (INBT inbt : list) {
            	File f = new File(file,inbt.iNBTFilename());
            	if (!f.exists()) CompressedStreamTools.writeGzippedCompoundToOutputStream(new NBTTagCompound(), new FileOutputStream(f));
            	NBTTagCompound compound = CompressedStreamTools.loadGzippedCompoundFromOutputStream(new FileInputStream(f));
            	inbt.iNBTSave(compound);
            	CompressedStreamTools.writeGzippedCompoundToOutputStream(compound,new FileOutputStream(f));
            }
        } catch(Exception exception) {exception.printStackTrace();}
        updateShouldLock(world);
    }

    public static void loadNBT(World world) {
        try {
        	File file = GetWorldSaveLocation(world);
            ArrayList<INBT> list = NBT.getList();
            for (INBT inbt : list) {
            	File f = new File(file,inbt.iNBTFilename());
            	if (!f.exists()) CompressedStreamTools.writeGzippedCompoundToOutputStream(new NBTTagCompound(), new FileOutputStream(f));
            	NBTTagCompound compound = CompressedStreamTools.loadGzippedCompoundFromOutputStream(new FileInputStream(f));
            	inbt.iNBTLoad(compound);
            }
        } catch (Exception exception) {exception.printStackTrace();}
        updateShouldLock(world);
        if (!SAPI.LockDifficulty.listLockingMods().isEmpty() && lockDifficulty == -1) counter = 1;
    }
    
    public static File GetWorldSaveLocation(World world) {
        return GetWorldSaveLocation(world.saveHandler);
    }

    public static File GetWorldSaveLocation(ISaveHandler isavehandler) {
        return (isavehandler instanceof SaveHandler) ? ((SaveHandler)isavehandler).getSaveDirectory() : null;
    }

	public String iNBTFilename() {
		return "SAPI.dat";
	}
	public void iNBTSave(NBTTagCompound compound) {
		NBTTagList list = new NBTTagList();
		for (Integer i : SAPI.Dimension.getOrder()) list.setTag(new NBTTagInt(i));
		compound.setTag("DimensionOrder",list);
        compound.setInteger("LockDifficulty",lockDifficulty);
	}
	public void iNBTLoad(NBTTagCompound compound) {
		SAPI.Dimension.clearOrder();
		NBTTagList list = compound.getTagList("DimensionOrder");
		for (int i = 0; i < list.tagCount(); i++) SAPI.Dimension.addToOrder(((NBTTagInt)list.tagAt(i)).intValue);

        lockDifficulty = -1;
        if(compound.hasKey("LockDifficulty")) lockDifficulty = compound.getInteger("LockDifficulty");
	}
}